"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createRouteMiddleware;
exports.setConfig = setConfig;

var _path = require("path");

var _getRouteConfig = _interopRequireDefault(require("./getRouteConfig"));

var _generateHTML = require("./generateHTML");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let config = null;

function createRouteMiddleware(root, _config, plugins, staticDirectory, libraryName, paths) {
  config = _config;
  const absPagesPath = paths.absPagesPath;
  return (req, res, next) => {
    const routeConfig = (0, _getRouteConfig.default)(absPagesPath);
    const _config2 = config,
          pagesConfig = _config2.pages;
    const path = req.path === '/' ? '/index.html' : req.path;

    if (routeConfig[path]) {
      const content = (0, _generateHTML.getHTMLContent)({
        route: path,
        entry: routeConfig[path],
        pagesPath: absPagesPath,
        root,
        pageConfig: pagesConfig && pagesConfig[path],
        plugins,
        staticDirectory,
        libraryName,
        paths
      });
      res.setHeader('Content-Type', 'text/html');
      res.send(content);
    } else {
      next();
    }
  };
}

function setConfig(_config) {
  config = _config;
}