"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _assert = _interopRequireDefault(require("assert"));

var _isPlainObject = _interopRequireDefault(require("is-plain-object"));

var _fs = require("fs");

var _path = require("path");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default() {
  return {
    name: 'theme',

    validate(val) {
      (0, _assert.default)(typeof val === 'string' || (0, _isPlainObject.default)(val), `"${this.relativeFile}" 的 "theme" 配置必须是 "字符串" 或 "Object 对象"，但你配置的是 ${val.toString()} 。`);
      const cwd = this.cwd;

      if (typeof val === 'string') {
        const themeFile = (0, _path.join)(cwd, val);
        (0, _assert.default)((0, _fs.existsSync)(themeFile), `"${this.relativeFile}" 的 "theme" 配置文件 "${themeFile.replace(`${cwd}/`, '')}" 不存在。`);
      }
    },

    watch(val) {
      if (typeof val === 'string') {
        const file = this.file;
        const themeFile = (0, _path.join)((0, _path.dirname)(file), val);
        this.watch(themeFile, this.onChange.bind(this));
      }
    },

    onChange() {
      this.restart(
      /* why */
      'Theme File Changed');
    }

  };
}

module.exports = exports["default"];